
//  PerinteinenWindowsSovellus.java  (c) 2004 Kari Laitinen

//  http://www.naturalprogramming.com

//  2004-10-24  File created.
//  2006-02-04  Vanha versio ohjelmasta nimelle
//              PerinteinenWindowsSovellusOLD.java
//              Tm ohjelma on muutettu Swing-perustaiseksi ohjelmaksi.
//  2006-02-04  Viimeisin muutos.

//  Katso kommentteja mys tiedoston lopusta!

//  Tm on Swing-luokkiin perustuva sovellus (siis ei apletti).
//  Tm on rakennettu siten ett sovelluksen toiminnot ovat
//  kaikki JFrame-luokasta johdetussa luokassa. Erillist paneeliluokkaa
//  ei tss kytet kuten esim. DrawingLinesApplication.java-ohjelmassa.

//  Tss on tytynyt rakentaa kaikki JFrame-perustaiseen luokkaan koska
//  menuja voi kiinnitt vain JFrame-perustaisiin olioihin.

import java.awt.* ;
import java.awt.event.*;

import javax.swing.* ;

class PerinteinenWindowsFrame extends JFrame implements ActionListener
{
   static final int WINDOW_WIDTH   =  500 ;
   static final int WINDOW_HEIGHT  =  400 ;

   JMenuItem  file_open_menu_item  =  new  JMenuItem( "Open" ) ;
   JMenuItem  file_save_menu_item  =  new  JMenuItem( "Save" ) ;
   JMenuItem  file_exit_menu_item  =  new  JMenuItem( "Exit" ) ;

   JMenuItem  edit_copy_menu_item  =  new  JMenuItem( "Copy" ) ;
   JMenuItem  edit_paste_menu_item =  new  JMenuItem( "Paste" ) ;

   JCheckBoxMenuItem  cyan_background_menu_item  =
                           new JCheckBoxMenuItem( "Cyan background" ) ;

   JRadioButtonMenuItem  small_text_menu_item  =
                                   new JRadioButtonMenuItem( "Small" ) ;
   JRadioButtonMenuItem  medium_text_menu_item  =
                                   new JRadioButtonMenuItem( "Medium" ) ;
   JRadioButtonMenuItem  large_text_menu_item  =
                                   new JRadioButtonMenuItem( "Large" ) ;

   JMenuItem  about_menu_item  =  new  JMenuItem( "About" ) ;

   String  viimeksi_valitun_menu_itemin_nimi  =  "EI VALINTOJA TEHTY." ;


   public PerinteinenWindowsFrame()
   {
      getContentPane().setBackground( Color.white ) ;

      setSize( WINDOW_WIDTH, WINDOW_HEIGHT ) ;

      setTitle( "PERINTEINEN WINDOWS-SOVELLUS MENUILLA" ) ;

      file_open_menu_item.setMnemonic( 'O' ) ;
      file_open_menu_item.addActionListener( this ) ;
      file_save_menu_item.setMnemonic( 'S' ) ;
      file_save_menu_item.addActionListener( this ) ;
      file_exit_menu_item.setMnemonic( 'x' ) ;
      file_exit_menu_item.addActionListener( this ) ;

      JMenu  file_menu  =  new  JMenu( "File" ) ;
      file_menu.setMnemonic( 'F' ) ;

      file_menu.add( file_open_menu_item ) ;
      file_menu.add( file_save_menu_item ) ;
      file_menu.add( file_exit_menu_item ) ;

      edit_copy_menu_item.addActionListener( this ) ;
      edit_paste_menu_item.addActionListener( this ) ;

      JMenu  edit_menu  =  new  JMenu( "Edit" ) ;

      edit_menu.add( edit_copy_menu_item ) ;
      edit_menu.add( edit_paste_menu_item ) ;

      JMenu  settings_menu  =  new  JMenu( "Settings" ) ;

      cyan_background_menu_item.addActionListener( this ) ;

      settings_menu.add( cyan_background_menu_item ) ;

      small_text_menu_item.addActionListener( this ) ;
      medium_text_menu_item.addActionListener( this ) ;
      large_text_menu_item.addActionListener( this ) ;

      medium_text_menu_item.setSelected( true ) ;

      ButtonGroup  text_size_button_group  =  new  ButtonGroup() ;

      text_size_button_group.add( small_text_menu_item ) ;
      text_size_button_group.add( medium_text_menu_item ) ;
      text_size_button_group.add( large_text_menu_item ) ;

      JMenu  text_size_menu  =  new  JMenu( "Text size" ) ;
      
      text_size_menu.add( small_text_menu_item ) ;
      text_size_menu.add( medium_text_menu_item ) ;
      text_size_menu.add( large_text_menu_item ) ;

      settings_menu.add( text_size_menu ) ;

      JMenu  help_menu  =  new  JMenu( "Help" ) ;

      about_menu_item.addActionListener( this ) ;
      help_menu.add( about_menu_item ) ;

      JMenuBar menubar_of_this_window  =  new JMenuBar() ;

      menubar_of_this_window.add( file_menu ) ;
      menubar_of_this_window.add( edit_menu ) ;
      menubar_of_this_window.add( settings_menu ) ;
      menubar_of_this_window.add( help_menu ) ;

      setJMenuBar( menubar_of_this_window ) ;

      setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE ) ;
   }


   //  Seuraava metodi "reagoi" menuista tehtyihin valintoihin.
   //  Useimmiten tehtyyn valintaan reagoidaan vain siten ett ruudulle
   //  tulostuu viimeisimmn valinnan teksti.
   //  Taustavrin valintaan reagoidaan asettamalla taustavriksi
   //  cyan, jos se on checkboxattuna, ja ruudulle tulee About-boksi
   //  jos kyttj valitsee Help -> About.

   //  paint()-metodi asettaa kirjoituskoon tekstin sen mukaan
   //  mik koko on kulloinkin valittuna.

   public void actionPerformed( ActionEvent event )
   {
      if ( event.getSource() instanceof JMenuItem )
      {
         JMenuItem valittu_menu_item  = (JMenuItem) event.getSource() ;

         viimeksi_valitun_menu_itemin_nimi  =  valittu_menu_item.getText() ;

         if ( cyan_background_menu_item.isSelected() == true )
         {
            getContentPane().setBackground( Color.cyan ) ;
         }
         else
         {
            getContentPane().setBackground( Color.white ) ;
         }

         if ( valittu_menu_item  ==  file_exit_menu_item )
         {
            setVisible( false ) ;
            System.exit( 0 ) ;
         }
         else if ( valittu_menu_item  ==  about_menu_item )
         {
            JOptionPane.showMessageDialog( this, 
                                 "Tm ohjelma matkii perinteist"
                               + "\nmenuihin perustuvaa windows-sovellusta",
                                 "About", JOptionPane.PLAIN_MESSAGE ) ;
         }

         repaint() ;
      }
   }


   //  Luokkaan kirjoitetaan paint()-metodi eik paintComponent()-metodia
   //  silloin kun Swing-sovellus rakennetaan siten ett kaikki
   //  tehdn JFrame-luokasta johdetussa luokassa, eik kytet
   //  erillist paneeliluokkaa kuten esim DrawingLinesApplication.java-
   //  ohjelmassa, 

   //  paint()-metodin alussa tulee kuitenkin kutsua ylluokan
   //  vastaavaa metodia.

   public void paint( Graphics graphics )
   {
      super.paint( graphics ) ;

      if ( small_text_menu_item.isSelected() == true )
      {
         graphics.setFont( new Font( "Serif", Font.PLAIN, 10 ) ) ;
      }

      if ( medium_text_menu_item.isSelected() == true )
      {
         graphics.setFont( new Font( "Serif", Font.PLAIN, 14 ) ) ;
      }

      if ( large_text_menu_item.isSelected() == true )
      {
         graphics.setFont( new Font( "Serif", Font.PLAIN, 18 ) ) ;
      }

      graphics.drawString( "Viimeisin tehty valinta on \""
                        +   viimeksi_valitun_menu_itemin_nimi  +  "\"",
                           100, 200 ) ;
   }
}

public class PerinteinenWindowsSovellus
{
   public static void main( String[] ei_kaytossa )
   {
      PerinteinenWindowsFrame  taman_sovelluksen_ikkuna  =
                                     new  PerinteinenWindowsFrame() ;

      taman_sovelluksen_ikkuna.setVisible( true ) ;
   }
}


/*******

    PerinteinenWindowsFrame-luokan konstruktorin lopussa oleva lause

       setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE ) ;

    aiheuttaa sen ett ohjelman suoritus pttyy kun ikkuna suljetaan.

    Toinen mahdollisuus saada aikaan tm toiminto olisi
    pist luokka toteuttamaan WindowListener-rajapinta ja lisksi
    pitisi konstruktoriin list seuraava lause

      addWindowListener( this ) ;

    Ja luokassa pitisi olla seuraavat metodit:

   //  Seuraava metodi toteuttaa osan WindowListener-rajapinnasta.

   public void windowClosing( WindowEvent event )
   {
      setVisible( false ) ;
      System.exit( 0 ) ;
   }

   //  Other methods required by the WindowListener interface:
   public void windowActivated( WindowEvent event ) {}
   public void windowClosed( WindowEvent event ) {}
   public void windowDeactivated( WindowEvent event ) {}
   public void windowDeiconified( WindowEvent event ) {}
   public void windowIconified( WindowEvent event )  { }
   public void windowOpened( WindowEvent event ) {}

*****/

